
/// Custom tags.
library custom;

import 'dart:async';
import 'builder.dart';
import 'html.dart';

part 'src/custom/drop_down.dart';
part 'src/custom/toggle_button.dart';

/// A function to bind to a custom element's [model].
///
/// Warning: once we are allowed to extend Element this is likely to be removed.
typedef void Bind(HasElement model);

final Tag dropDown = ([Build b, Bind bind]) => 
    build(() => _bind(new DropDown(), bind), b);

final Tag toggleButton = ([Build b, Bind bind]) => 
    build(() => _bind(new ToggleButton(), bind), b);

// TODO(rms): consider making this public if the need / want arises.
Element _bind(HasElement model, Bind bind) {
  if (bind != null) bind(model);
  return model.element;
}

/// An object that has an element.
///
/// Warning: once we are allowed to extend Element this is likely to be removed.
abstract class HasElement {
  Element get element;
}
